@caido/quickjs-types / llrt/url / url
url
Classes
URL
Browser-compatible URL class, implemented by following the WHATWG URL Standard. Examples of parsed URLs may be found in the Standard itself. The URL class is also available on the global object.
In accordance with browser conventions, all properties of URL objects are implemented as getters and setters on the class prototype, rather than as data properties on the object itself. Thus, unlike legacy urlObjects, using the delete keyword on any properties of URL objects (e.g. delete myURL.protocol, delete myURL.pathname, etc) has no effect but will still return true.
Extended by
Constructors
Constructor
new URL(
input:string| {toString: () =>string; },base?:string|URL):URL
Parameters
| Parameter | Type |
|---|---|
input | string | { toString: () => string; } |
base? | string | URL |
Returns
Properties
hash
hash:
string
Gets and sets the fragment portion of the URL.
const myURL = new URL('https://example.org/foo#bar');
console.log(myURL.hash);
// Prints #bar
myURL.hash = 'baz';
console.log(myURL.href);
// Prints https://example.org/foo#bazInvalid URL characters included in the value assigned to the hash property are percent-encoded. The selection of which characters to percent-encode may vary somewhat from what the parse and format methods would produce.
host
host:
string
Gets and sets the host portion of the URL.
const myURL = new URL('https://example.org:81/foo');
console.log(myURL.host);
// Prints example.org:81
myURL.host = 'example.com:82';
console.log(myURL.href);
// Prints https://example.com:82/fooInvalid host values assigned to the host property are ignored.
hostname
hostname:
string
Gets and sets the host name portion of the URL. The key difference betweenurl.host and url.hostname is that url.hostname does not include the port.
const myURL = new URL('https://example.org:81/foo');
console.log(myURL.hostname);
// Prints example.org
// Setting the hostname does not change the port
myURL.hostname = 'example.com';
console.log(myURL.href);
// Prints https://example.com:81/foo
// Use myURL.host to change the hostname and port
myURL.host = 'example.org:82';
console.log(myURL.href);
// Prints https://example.org:82/fooInvalid host name values assigned to the hostname property are ignored.
href
href:
string
Gets and sets the serialized URL.
const myURL = new URL('https://example.org/foo');
console.log(myURL.href);
// Prints https://example.org/foo
myURL.href = 'https://example.com/bar';
console.log(myURL.href);
// Prints https://example.com/barGetting the value of the href property is equivalent to calling toString.
Setting the value of this property to a new value is equivalent to creating a new URL object using new URL(value). Each of the URL object's properties will be modified.
If the value assigned to the href property is not a valid URL, a TypeError will be thrown.
origin
readonlyorigin:string
Gets the read-only serialization of the URL's origin.
const myURL = new URL('https://example.org/foo/bar?baz');
console.log(myURL.origin);
// Prints https://example.orgconst idnURL = new URL('https://測試');
console.log(idnURL.origin);
// Prints https://xn--g6w251d
console.log(idnURL.hostname);
// Prints xn--g6w251dpassword
password:
string
Gets and sets the password portion of the URL.
const myURL = new URL('https://abc:xyz@example.com');
console.log(myURL.password);
// Prints xyz
myURL.password = '123';
console.log(myURL.href);
// Prints https://abc:123@example.com/Invalid URL characters included in the value assigned to the password property are percent-encoded. The selection of which characters to percent-encode may vary somewhat from what the parse and format methods would produce.
pathname
pathname:
string
Gets and sets the path portion of the URL.
const myURL = new URL('https://example.org/abc/xyz?123');
console.log(myURL.pathname);
// Prints /abc/xyz
myURL.pathname = '/abcdef';
console.log(myURL.href);
// Prints https://example.org/abcdef?123Invalid URL characters included in the value assigned to the pathname property are percent-encoded. The selection of which characters to percent-encode may vary somewhat from what the parse and format methods would produce.
port
port:
string
Gets and sets the port portion of the URL.
The port value may be a number or a string containing a number in the range 0 to 65535 (inclusive). Setting the value to the default port of the URL objects given protocol will result in the port value becoming the empty string ('').
The port value can be an empty string in which case the port depends on the protocol/scheme.
Upon assigning a value to the port, the value will first be converted to a string using .toString().
If that string is invalid but it begins with a number, the leading number is assigned to port. If the number lies outside the range denoted above, it is ignored.
const myURL = new URL('https://example.org:8888');
console.log(myURL.port);
// Prints 8888
// Default ports are automatically transformed to the empty string
// (HTTPS protocol's default port is 443)
myURL.port = '443';
console.log(myURL.port);
// Prints the empty string
console.log(myURL.href);
// Prints https://example.org/
myURL.port = 1234;
console.log(myURL.port);
// Prints 1234
console.log(myURL.href);
// Prints https://example.org:1234/
// Completely invalid port strings are ignored
myURL.port = 'abcd';
console.log(myURL.port);
// Prints 1234
// Leading numbers are treated as a port number
myURL.port = '5678abcd';
console.log(myURL.port);
// Prints 5678
// Non-integers are truncated
myURL.port = 1234.5678;
console.log(myURL.port);
// Prints 1234
// Out-of-range numbers which are not represented in scientific notation
// will be ignored.
myURL.port = 1e10; // 10000000000, will be range-checked as described below
console.log(myURL.port);
// Prints 1234Numbers which contain a decimal point, such as floating-point numbers or numbers in scientific notation, are not an exception to this rule. Leading numbers up to the decimal point will be set as the URL's port, assuming they are valid:
myURL.port = 4.567e21;
console.log(myURL.port);
// Prints 4 (because it is the leading number in the string '4.567e21')protocol
protocol:
string
Gets and sets the protocol portion of the URL.
const myURL = new URL('https://example.org');
console.log(myURL.protocol);
// Prints https:
myURL.protocol = 'ftp';
console.log(myURL.href);
// Prints ftp://example.org/Invalid URL protocol values assigned to the protocol property are ignored.
search
search:
string
Gets and sets the serialized query portion of the URL.
const myURL = new URL('https://example.org/abc?123');
console.log(myURL.search);
// Prints ?123
myURL.search = 'abc=xyz';
console.log(myURL.href);
// Prints https://example.org/abc?abc=xyzAny invalid URL characters appearing in the value assigned the search property will be percent-encoded. The selection of which characters to percent-encode may vary somewhat from what the parse and format methods would produce.
searchParams
readonlysearchParams:URLSearchParams
Gets the URLSearchParams object representing the query parameters of the URL. This property is read-only but the URLSearchParams object it provides can be used to mutate the URL instance; to replace the entirety of query parameters of the URL, use the search setter. See URLSearchParams documentation for details.
Use care when using .searchParams to modify the URL because, per the WHATWG specification, the URLSearchParams object uses different rules to determine which characters to percent-encode. For instance, the URL object will not percent encode the ASCII tilde (~) character, while URLSearchParams will always encode it:
const myURL = new URL('https://example.org/abc?foo=~bar');
console.log(myURL.search); // prints ?foo=~bar
// Modify the URL via searchParams...
myURL.searchParams.sort();
console.log(myURL.search); // prints ?foo=%7Ebarusername
username:
string
Gets and sets the username portion of the URL.
const myURL = new URL('https://abc:xyz@example.com');
console.log(myURL.username);
// Prints abc
myURL.username = '123';
console.log(myURL.href);
// Prints https://123:xyz@example.com/Any invalid URL characters appearing in the value assigned the username property will be percent-encoded. The selection of which characters to percent-encode may vary somewhat from what the parse and format methods would produce.
Methods
toJSON()
toJSON():
string
The toJSON() method on the URL object returns the serialized URL. The value returned is equivalent to that of href and toString.
This method is automatically called when an URL object is serialized with JSON.stringify().
const myURLs = [
new URL('https://www.example.com'),
new URL('https://test.example.org'),
];
console.log(JSON.stringify(myURLs));
// Prints ["https://www.example.com/","https://test.example.org/"]Returns
string
toString()
toString():
string
The toString() method on the URL object returns the serialized URL. The value returned is equivalent to that of href and toJSON.
Returns
string
canParse()
staticcanParse(input:string,base?:string):boolean
Checks if an input relative to the base can be parsed to a URL.
const isValid = URL.canParse('/foo', 'https://example.org/'); // true
const isNotValid = URL.canParse('/foo'); // falseParameters
| Parameter | Type | Description |
|---|---|---|
input | string | The absolute or relative input URL to parse. If input is relative, then base is required. If input is absolute, the base is ignored. If input is not a string, it is converted to a string first. |
base? | string | The base URL to resolve against if the input is not absolute. If base is not a string, it is converted to a string first. |
Returns
boolean
parse()
staticparse(input:string,base?:string):URL|null
Parses a string as a URL. If base is provided, it will be used as the base URL for the purpose of resolving non-absolute input URLs. Returns null if input is not a valid.
Parameters
| Parameter | Type | Description |
|---|---|---|
input | string | The absolute or relative input URL to parse. If input is relative, then base is required. If input is absolute, the base is ignored. If input is not a string, it is converted to a string first. |
base? | string | The base URL to resolve against if the input is not absolute. If base is not a string, it is converted to a string first. |
Returns
URL | null
URLSearchParams
The URLSearchParams API provides read and write access to the query of a URL. The URLSearchParams class can also be used standalone with one of the four following constructors. The URLSearchParams class is also available on the global object.
The WHATWG URLSearchParams interface and the querystring module have similar purpose, but the purpose of the querystring module is more general, as it allows the customization of delimiter characters (& and =). On the other hand, this API is designed purely for URL query strings.
const myURL = new URL('https://example.org/?abc=123');
console.log(myURL.searchParams.get('abc'));
// Prints 123
myURL.searchParams.append('abc', 'xyz');
console.log(myURL.href);
// Prints https://example.org/?abc=123&abc=xyz
myURL.searchParams.delete('abc');
myURL.searchParams.set('a', 'b');
console.log(myURL.href);
// Prints https://example.org/?a=b
const newSearchParams = new URLSearchParams(myURL.searchParams);
// The above is equivalent to
// const newSearchParams = new URLSearchParams(myURL.search);
newSearchParams.append('a', 'c');
console.log(myURL.href);
// Prints https://example.org/?a=b
console.log(newSearchParams.toString());
// Prints a=b&a=c
// newSearchParams.toString() is implicitly called
myURL.search = newSearchParams;
console.log(myURL.href);
// Prints https://example.org/?a=b&a=c
newSearchParams.delete('a');
console.log(myURL.href);
// Prints https://example.org/?a=b&a=cExtended by
Implements
Iterable<[string,string]>
Constructors
Constructor
new URLSearchParams(
init?:string|Iterable<[string,string],any,any> |URLSearchParams|Record<string,string| readonlystring[]> | readonly [string,string][]):URLSearchParams
Parameters
| Parameter | Type |
|---|---|
init? | string | Iterable<[string, string], any, any> | URLSearchParams | Record<string, string | readonly string[]> | readonly [string, string][] |
Returns
Methods
[iterator]()
[iterator]():
IterableIterator<[string,string]>
Returns
IterableIterator<[string, string]>
Implementation of
Iterable.[iterator]
append()
append(
name:string,value:string):void
Append a new name-value pair to the query string.
Parameters
| Parameter | Type |
|---|---|
name | string |
value | string |
Returns
void
delete()
delete(
name:string,value?:string):void
If value is provided, removes all name-value pairs where name is name and value is value.
If value is not provided, removes all name-value pairs whose name is name.
Parameters
| Parameter | Type |
|---|---|
name | string |
value? | string |
Returns
void
entries()
entries():
IterableIterator<[string,string]>
Returns an ES6 Iterator over each of the name-value pairs in the query. Each item of the iterator is a JavaScript Array. The first item of the Array is the name, the second item of the Array is the value.
Alias for urlSearchParams[@@iterator]().
Returns
IterableIterator<[string, string]>
forEach()
forEach<
TThis>(fn: (this:TThis,value:string,name:string,searchParams:URLSearchParams) =>void,thisArg?:TThis):void
Iterates over each name-value pair in the query and invokes the given function.
const myURL = new URL('https://example.org/?a=b&c=d');
myURL.searchParams.forEach((value, name, searchParams) => {
console.log(name, value, myURL.searchParams === searchParams);
});
// Prints:
// a b true
// c d trueType Parameters
| Type Parameter | Default type |
|---|---|
TThis | URLSearchParams |
Parameters
| Parameter | Type | Description |
|---|---|---|
fn | (this: TThis, value: string, name: string, searchParams: URLSearchParams) => void | Invoked for each name-value pair in the query |
thisArg? | TThis | To be used as this value for when fn is called |
Returns
void
get()
get(
name:string):string|null
Returns the value of the first name-value pair whose name is name. If there are no such pairs, null is returned.
Parameters
| Parameter | Type |
|---|---|
name | string |
Returns
string | null
or null if there is no name-value pair with the given name.
has()
has(
name:string,value?:string):boolean
Checks if the URLSearchParams object contains key-value pair(s) based on name and an optional value argument.
If value is provided, returns true when name-value pair with same name and value exists.
If value is not provided, returns true if there is at least one name-value pair whose name is name.
Parameters
| Parameter | Type |
|---|---|
name | string |
value? | string |
Returns
boolean
keys()
keys():
IterableIterator<string>
Returns an ES6 Iterator over the names of each name-value pair.
const params = new URLSearchParams('foo=bar&foo=baz');
for (const name of params.keys()) {
console.log(name);
}
// Prints:
// foo
// fooReturns
IterableIterator<string>
set()
set(
name:string,value:string):void
Sets the value in the URLSearchParams object associated with name to value. If there are any pre-existing name-value pairs whose names are name, set the first such pair's value to value and remove all others. If not, append the name-value pair to the query string.
const params = new URLSearchParams();
params.append('foo', 'bar');
params.append('foo', 'baz');
params.append('abc', 'def');
console.log(params.toString());
// Prints foo=bar&foo=baz&abc=def
params.set('foo', 'def');
params.set('xyz', 'opq');
console.log(params.toString());
// Prints foo=def&abc=def&xyz=opqParameters
| Parameter | Type |
|---|---|
name | string |
value | string |
Returns
void
sort()
sort():
void
Sort all existing name-value pairs in-place by their names. Sorting is done with a stable sorting algorithm, so relative order between name-value pairs with the same name is preserved.
This method can be used, in particular, to increase cache hits.
const params = new URLSearchParams('query[]=abc&type=search&query[]=123');
params.sort();
console.log(params.toString());
// Prints query%5B%5D=abc&query%5B%5D=123&type=searchReturns
void
toString()
toString():
string
Returns the search parameters serialized as a string, with characters percent-encoded where necessary.
Returns
string
values()
values():
IterableIterator<string>
Returns an ES6 Iterator over the values of each name-value pair.
Returns
IterableIterator<string>
Interfaces
Url
Properties
auth
auth:
string|null
hash
hash:
string|null
host
host:
string|null
hostname
hostname:
string|null
href
href:
string
path
path:
string|null
pathname
pathname:
string|null
port
port:
string|null
protocol
protocol:
string|null
query
query:
string|null
search
search:
string|null
slashes
slashes:
boolean|null
URLFormatOptions
Properties
auth?
optionalauth:boolean
true if the serialized URL string should include the username and password, false otherwise.
Default
truefragment?
optionalfragment:boolean
true if the serialized URL string should include the fragment, false otherwise.
Default
truesearch?
optionalsearch:boolean
true if the serialized URL string should include the search query, false otherwise.
Default
trueunicode?
optionalunicode:boolean
true if Unicode characters appearing in the host component of the URL string should be encoded directly as opposed to being Punycode encoded.
Default
falseFunctions
domainToASCII()
domainToASCII(
domain:string):string
Returns the Punycode ASCII serialization of the domain. If domain is an invalid domain, the empty string is returned.
It performs the inverse operation to domainToUnicode.
import url from 'url';
console.log(url.domainToASCII('español.com'));
// Prints xn--espaol-zwa.com
console.log(url.domainToASCII('中文.com'));
// Prints xn--fiq228c.com
console.log(url.domainToASCII('xn--iñvalid.com'));
// Prints an empty stringParameters
| Parameter | Type |
|---|---|
domain | string |
Returns
string
domainToUnicode()
domainToUnicode(
domain:string):string
Returns the Unicode serialization of the domain. If domain is an invalid domain, the empty string is returned.
It performs the inverse operation to domainToASCII.
import url from 'url';
console.log(url.domainToUnicode('xn--espaol-zwa.com'));
// Prints español.com
console.log(url.domainToUnicode('xn--fiq228c.com'));
// Prints 中文.com
console.log(url.domainToUnicode('xn--iñvalid.com'));
// Prints an empty stringParameters
| Parameter | Type |
|---|---|
domain | string |
Returns
string
fileURLToPath()
fileURLToPath(
url:string|URL):string
This function ensures the correct decodings of percent-encoded characters as well as ensuring a cross-platform valid absolute path string.
import { fileURLToPath } from 'url';
const __filename = fileURLToPath(import.meta.url);
new URL('file:///C:/path/').pathname; // Incorrect: /C:/path/
fileURLToPath('file:///C:/path/'); // Correct: C:\path\ (Windows)
new URL('file://nas/foo.txt').pathname; // Incorrect: /foo.txt
fileURLToPath('file://nas/foo.txt'); // Correct: \\nas\foo.txt (Windows)
new URL('file:///你好.txt').pathname; // Incorrect: /%E4%BD%A0%E5%A5%BD.txt
fileURLToPath('file:///你好.txt'); // Correct: /你好.txt (POSIX)
new URL('file:///hello world').pathname; // Incorrect: /hello%20world
fileURLToPath('file:///hello world'); // Correct: /hello world (POSIX)Parameters
| Parameter | Type | Description |
|---|---|---|
url | string | URL | The file URL string or URL object to convert to a path. |
Returns
string
The fully-resolved platform-specific Node.js file path.
format()
format(
urlObject:URL,options?:URLFormatOptions):string
The url.format() method returns a formatted URL string derived from urlObject.
const url = require('url');
url.format({
protocol: 'https',
hostname: 'example.com',
pathname: '/some/path',
query: {
page: 1,
format: 'json',
},
});
// => 'https://example.com/some/path?page=1&format=json'If urlObject is not an object or a string, url.format() will throw a TypeError.
The formatting process operates as follows:
- A new empty string
resultis created. - If
urlObject.protocolis a string, it is appended as-is toresult. - Otherwise, if
urlObject.protocolis notundefinedand is not a string, anErroris thrown. - For all string values of
urlObject.protocolthat do not end with an ASCII colon (:) character, the literal string:will be appended toresult. - If either of the following conditions is true, then the literal string
//will be appended toresult:urlObject.slashesproperty is true;urlObject.protocolbegins withhttp,https,ftp,gopher, orfile;
- If the value of the
urlObject.authproperty is truthy, and eitherurlObject.hostorurlObject.hostnameare notundefined, the value ofurlObject.authwill be coerced into a string and appended toresultfollowed by the literal string@. - If the
urlObject.hostproperty isundefinedthen:- If the
urlObject.hostnameis a string, it is appended toresult. - Otherwise, if
urlObject.hostnameis notundefinedand is not a string, anErroris thrown. - If the
urlObject.portproperty value is truthy, andurlObject.hostnameis notundefined: * The literal string:is appended toresult, and * The value ofurlObject.portis coerced to a string and appended toresult.
- If the
- Otherwise, if the
urlObject.hostproperty value is truthy, the value ofurlObject.hostis coerced to a string and appended toresult. - If the
urlObject.pathnameproperty is a string that is not an empty string:- If the
urlObject.pathnamedoes not start with an ASCII forward slash (/), then the literal string'/'is appended toresult. - The value of
urlObject.pathnameis appended toresult.
- If the
- Otherwise, if
urlObject.pathnameis notundefinedand is not a string, anErroris thrown. - If the
urlObject.searchproperty isundefinedand if theurlObject.queryproperty is anObject, the literal string?is appended toresultfollowed by the output of calling thequerystringmodule'sstringify()method passing the value ofurlObject.query. - Otherwise, if
urlObject.searchis a string:- If the value of
urlObject.searchdoes not start with the ASCII question mark (?) character, the literal string?is appended toresult. - The value of
urlObject.searchis appended toresult.
- If the value of
- Otherwise, if
urlObject.searchis notundefinedand is not a string, anErroris thrown. - If the
urlObject.hashproperty is a string:- If the value of
urlObject.hashdoes not start with the ASCII hash (#) character, the literal string#is appended toresult. - The value of
urlObject.hashis appended toresult.
- If the value of
- Otherwise, if the
urlObject.hashproperty is notundefinedand is not a string, anErroris thrown. resultis returned.
Parameters
| Parameter | Type | Description |
|---|---|---|
urlObject | URL | A URL object (as returned by url.parse() or constructed otherwise). If a string, it is converted to an object by passing it to url.parse(). |
options? | URLFormatOptions | - |
Returns
string
Legacy
Use the WHATWG URL API instead.
parse()
parse(
urlString:string,parseQueryString?:boolean,slashesDenoteHost?:boolean):Url
The url.parse() method takes a URL string, parses it, and returns a URL object.
A TypeError is thrown if urlString is not a string.
A URIError is thrown if the auth property is present but cannot be decoded.
url.parse() uses a lenient, non-standard algorithm for parsing URL strings. It is prone to security issues such as host name spoofing and incorrect handling of usernames and passwords. Do not use with untrusted input. CVEs are not issued for url.parse() vulnerabilities. Use the WHATWG URL API instead.
Parameters
| Parameter | Type | Description |
|---|---|---|
urlString | string | The URL string to parse. |
parseQueryString? | boolean | If true, the query property will always be set to an object returned by the querystring module's parse() method. If false, the query property on the returned URL object will be an unparsed, undecoded string. |
slashesDenoteHost? | boolean | If true, the first token after the literal string // and preceding the next / will be interpreted as the host. For instance, given //foo/bar, the result would be {host: 'foo', pathname: '/bar'} rather than {pathname: '//foo/bar'}. |
Returns
Deprecated
Use the WHATWG URL API instead.
pathToFileURL()
pathToFileURL(
path:string):URL
This function ensures that path is resolved absolutely, and that the URL control characters are correctly encoded when converting into a File URL.
import { pathToFileURL } from 'url';
new URL('/foo#1', 'file:'); // Incorrect: file:///foo#1
pathToFileURL('/foo#1'); // Correct: file:///foo%231 (POSIX)
new URL('/some/path%.c', 'file:'); // Incorrect: file:///some/path%.c
pathToFileURL('/some/path%.c'); // Correct: file:///some/path%25.c (POSIX)Parameters
| Parameter | Type | Description |
|---|---|---|
path | string | The path to convert to a File URL. |
Returns
The file URL object.
urlToHttpOptions()
urlToHttpOptions(
url:URL):Object
This utility function converts a URL object into an ordinary options object as expected by the http.request() and https.request() APIs.
import { urlToHttpOptions } from 'url';
const myURL = new URL('https://a:b@測試?abc#foo');
console.log(urlToHttpOptions(myURL));
/*
{
protocol: 'https:',
hostname: 'xn--g6w251d',
hash: '#foo',
search: '?abc',
pathname: '/',
path: '/?abc',
href: 'https://a:b@xn--g6w251d/?abc#foo',
auth: 'a:b'
}Parameters
| Parameter | Type | Description |
|---|---|---|
url | URL | The WHATWG URL object to convert to an options object. |
Returns
Object
Options object
